;;; -*- Mode: LISP; Syntax: Common-lisp; Package: USER; Base: 10 -*-
;;;
;;;  Copyright (C) 1989,1990 Aoyama Gakuin University
;;;
;;;		All Rights Reserved
;;;
;;; This software is developed for the YY project of Aoyama Gakuin University.
;;; Permission to use, copy, modify, and distribute this software
;;; and its documentation for any purpose and without fee is hereby granted,
;;; provided that the above copyright notices appear in all copies and that
;;; both that copyright notice and this permission notice appear in 
;;; supporting documentation, and that the name of Aoyama Gakuin
;;; not be used in advertising or publicity pertaining to distribution of
;;; the software without specific, written prior permission.
;;;
;;; This software is made available AS IS, and Aoyama Gakuin makes no
;;; warranty about the software, its performance or its conformity to
;;; any specification. 
;;;
;;; To make a contact: Send E-mail to ida@csrl.aoyama.ac.jp for overall
;;; issues. To ask specific questions, send to the individual authors at
;;; csrl.aoyama.ac.jp. To request a mailing list, send E-mail to 
;;; yyonx-request@csrl.aoyama.ac.jp.
;;;
;;; Authors:
;;;   version 1.0 90/06/01 by t.kosaka (kosaka@csrl.aoyama.ac.jp)
;;;   version 1.1 90/07/31 by t.kosaka
;;;   update 1.11 90/09/14 by t.kosaka
;;;   version 1.2 90/11/05 by t.kosaka
;;;		  Symbolics Codes contribution of E.Shiota
;;;   version 1.4 91/07/19 by Y.Ohta	(yohta@csrl.aoyama.ac.jp)

(in-package :user)

(DEFPACKAGE YY
  (:SIZE 500)
  #+Allegro-V4.0      (:USE lisp system clos)
  #+Lucid     (:USE lisp system lucid-common-lisp)
  #+Symbolics (:USE CLOS COMMON-LISP)
  #+CMU       (:USE "EXTENSIONS" "COMMON-LISP" "PCL" "SYSTEM" "ALIEN" "C-CALL")
  (:shadow
    READ-CHAR PEEK-CHAR UNREAD-CHAR LISTEN READ-LINE CLEAR-INPUT READ-CHAR-NO-HANG
    WRITE-CHAR FRESH-LINE TERPRI WRITE-STRING WRITE-LINE FORCE-OUTPUT FINISH-OUTPUT
    READ-BYTE MAKE-STRING-INPUT-STREAM CLEAR-OUTPUT
    ;;;INPUT-STREAM-P OUTPUT-STREAM-P
    OUTPUT-STREAM-P STREAMP READ
    ;;;MAKE-STRING-OUTPUT-STREAM GET-OUTPUT-STREAM-STRING
    ;; Followings are only symbolics version
    #+Symbolics SETF
    #+Symbolics DOCUMENTATION
    ;;;PCL's defgeneric is not supported yet :Method option,
    ;;;then yy:defgeneric expands pcl:defgeneric and pcl:defmethod. 
    #+PCL pcl:defgeneric
    )
  #+Symbolics (:import-from CLOS SETF DOCUMENTATION)
;  (:IMPORT )
  (:EXPORT INITIALIZE-YY))

(DEFPACKAGE yy-defsystem
  (:size 200)
  (:use LISP SYSTEM)
  (:export
   defsystem operate-on-system))


